ideal
public	_sbinit
public	_sbclose
public	_sbwait
public	_sbdsp
public	_sberr
public	_sbespk
public	_sbdspk
public	_sbplay
public	_sbplay2
public	_sbtime
public	_sbcomp
public	_sbreset
public	_sbchs
model	tiny
codeseg
; 
; Initialize SB routines
; DX=base address (210h, 220h, 230h, 240h, 250h, 260h, 280h)
; BL=IRQ channel (2,3,5,7)
; BH=DMA channel (0,1,3)
proc	_sbinit
	mov	[cs:sbbase],dx
	mov	[word cs:sbirq],bx
	mov	al,bh
	and	al,3
	or	al,4
	out	0Ah,al
	and	bx,7
	mov	cl,bl
	mov	ah,0FEh
	rol	ah,cl
	in	al,21h
	mov	[cs:oldpic],al
	and	al,ah
	out	21h,al
	add	bl,8
	add	bx,bx
	add	bx,bx
	mov	ax,[cs:oldint+2]
	inc	ax
	jnz	@@m1
	cli
	push	ds
	xor	ax,ax
	mov	ds,ax
	mov	ax,[bx]
	mov	[cs:oldint],ax
	mov	ax,[bx+2]
	mov	[cs:oldint+2],ax
	mov	[word bx],offset _sbint
	mov	[word bx+2],cs
	pop	ds
	sti
	mov	bx,offset @pgdma
	mov	al,[cs:sbdma]
	and	al,3
	segcs
	xlat
	mov	[cs:pgdma],al
@@m1:	mov	dx,[cs:sbbase]
	call	_sbreset
	jnc	@@m3
	mov	[cs:_sberr],1
;	stc
@@m3:	ret
endp
; 
; Restore IRQ handle
proc	_sbclose
	mov	al,[cs:oldpic]
	out	21h,al
	mov	bl,[cs:sbirq]
	add	bl,8
	mov	bh,0
	add	bx,bx
	add	bx,bx
	mov	ax,[cs:oldint+2]
	inc	ax
	jz	@@m1
	cli
	push	ds
	xor	ax,ax
	mov	ds,ax
	mov	ax,[cs:oldint]
	mov	[bx],ax
	mov	ax,[cs:oldint+2]
	mov	[bx+2],ax
	mov	[cs:oldint],0
	mov	[cs:oldint+2],0FFFFh
	pop	ds
	sti
@@m1:
	ret
endp
; 
proc	_sbreset
	mov	[cs:sbbase],dx
	add	dx,6
	mov	al,1
	out	dx,al
	mov	cx,200
@@1:	in	al,0EDh
	loop	@@1
	mov	al,0
	out	dx,al
	add	dx,8
@@m2:	in	al,dx
	test	al,80h
	loopz	@@m2
	jcxz	@@m3
	sub	dx,4
	in	al,dx
	sub	dx,10
	cmp	al,0AAh
	jz	@@m3
	stc
@@m3:	ret
endp
; 
; Wait DMA
proc	_sbwait
;	mov	cl,[cs:sbdma]
;	and	cl,3
;	mov	ah,1
;	rol	ah,cl
;	in	al,8
;	and	al,ah
;	jnz	@@m1
@@m0:	mov	al,[cs:enddma]
	and	al,al
	jnz	@@m1
	hlt
	jmp	@@m0
@@m1:	ret
endp
; 
; Internal: SB interrupt
proc	_sbint
	push	ax dx
	mov	dx,[cs:sbbase]
	add	dx,0Eh
	in	al,dx
	mov	al,20h
	out	20h,al
	mov	ax,[word cs:pllen]
	or	al,ah
	or	al,[byte cs:pllen+2]
	jz	@@m1
	;int	3
	out	0ch,al
	mov	al,[cs:pllen+3]
	inc	al
	mov	[cs:pllen+3],al
	mov	dl,[cs:pgdma]
	mov	dh,0
	out	dx,al
	mov	dl,[cs:sbdma]
	and	dl,3
	add	dl,dl
	xor	al,al
	out	dx,al
	jmp	short $+2
	out	dx,al
	inc	dx
	cmp	[byte cs:pllen+2],0
	jz	@@m3
	xor	ax,ax
	jmp	@@m4
@@m3:	mov	ax,[word cs:pllen]
@@m4:	dec	ax
	push	bx
	call	[dword cs:dmacnt]
	pop	bx
	jmp	@@m2	
@@m1:	mov	[cs:enddma],1
@@m2:	pop	dx ax
	iret
endp
; 
; Set time constant (AL)
proc	_sbtime
	mov	bx,offset @settime
	mov	[cs:bx+2],al
	jmp	sbdsp
endp
; 
; Internal: Call DSP
proc	sbdsp
	push	ds cs
	pop	ds
	call	_sbdsp
	pop	ds
	ret
endp
; 
; Enable speaker
proc	_sbespk
	mov	bx,offset @enspk
	jmp	sbdsp
endp
; 
; Disable speaker
proc	_sbdspk
	mov	bx,offset @dispk
	jmp	sbdsp
endp
; 
; DMA 8-bit DAC
; ES:BX=address to play
; CL:DX=length
proc	_sbplay2
	mov	ax,es
	rol	ax,1
	rol	ax,1
	rol	ax,1
	rol	ax,1
	push	ax
	and	ax,0FFF0h
	add	bx,ax
	pop	ax
	pushf
	and	al,0Fh
	popf
	adc	al,0
	mov	ch,al
; CH:BX=physical address
; CL:DX=length
_sbplay:
	mov	[word cs:pllen],dx
	mov	[word cs:pllen+2],cx
	mov	[cs:enddma],0
	out	0Ch,al
	mov	al,[cs:sbdma]
	and	al,3
	add	al,58h
	out	0Bh,al
	jmp	short $+2
	mov	dl,[cs:sbdma]
	mov	dh,0
	add	dx,dx
	mov	al,bl
	out	dx,al
	jmp	short $+2
	mov	al,bh
	out	dx,al
	jmp	short $+2
	push	dx
	mov	dl,[cs:pgdma]
	mov	al,ch
	out	dx,al
	pop	dx
	inc	dx
	mov	cx,bx
	not	cx
	cmp	[byte cs:pllen+2],0
	jnz	@@m1
	mov	ax,[word cs:pllen]
	dec	ax
	cmp	ax,cx
	jbe	@@m2
@@m1:	mov	ax,cx
@@m2:	mov	[cs:dmacnt],offset @@mp
	mov	[cs:dmacnt+2],cs
	call	[dword cs:dmacnt]
	ret
@@mp:	out	0Ch,al
	jmp	short $+2
	stc
	sbb	[word cs:pllen],ax
	sbb	[byte cs:pllen+2],0
	mov	bx,offset @play
	mov	[cs:bx+2],ax
	out	dx,al
	jmp	short $+2
	mov	al,ah
	out	dx,al
	mov	al,[cs:sbirq+1]
	and	al,3
	out	0Ah,al

	call	sbdsp
	retf
endp
; 
proc	_sbcomp
	mov	[@play+1],al
	ret
endp
; 
proc	_sbchs
	push	dx ax
	mov	dx,[cs:sbbase]
	add	dx,4
	mov	ah,al
	mov	al,0Eh
	out	dx,al
	inc	dx
	in	al,dx
	and	al,0FDh
	and	ah,1
	shl	ah,1
	or	al,ah
	out	dx,al
	pop	ax dx
	ret
endp
; 
; Call DSP
proc	_sbdsp
	push	ax cx dx
	mov	ah,[bx]
	inc	bx
	mov	dx,[cs:sbbase]
	add	dl,0Ch
@@m0:	xor	cx,cx
@@m1:	in	al,dx
	test	al,80h
	loopnz	@@m1
	jcxz	@@m2
	mov	al,[bx]
	out	dx,al
	inc	bx
	dec	ah
	jnz	@@m0
@@m3:	pop	dx cx ax
	ret
@@m2:	mov	[cs:_sberr],2
	jmp	@@m3
endp
; 
_sberr	dw	0
; 0 = OK
; 1 = Initialize error
; 2 = Write error
; 
@settime db	2,40h,0
@enspk	db	1,0D1h
@dispk	db	1,0D2h
@play	db	3,14h,0,0
; 
enddma	db	0
@pgdma	db	87h,83h,81h,82h
pllen	db	0,0,0,0
oldint	dw	0,0FFFFh
dmacnt	dw	0,0
sbbase	dw	220h
sbirq	db	5
sbdma	db	1
pgdma	db	0
oldpic	db	0
end